<template>
  <div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="row">
          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Kode Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Kode Proyek"
              v-model="filter.code"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Owner Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Owner"
              v-model="filter.owner"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nama Proyek</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nama Proyek"
              v-model="filter.name"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Nomor Kontrak</label>

            <b-form-input
              id="input-large"
              size="lg"
              placeholder="Masukkan Nomor Kontrak"
              v-model="filter.contract_num"
            ></b-form-input>
          </div>

          <div class="col-md-6 py-2 col-sm-12">
            <label for="input-large">Status</label>

            <b-form-select
              v-model="filter.status"
              :options="options.statuses"
              size="lg"
            ></b-form-select>
          </div>
        </div>

        <div class="d-flex justify-content-end">
          <button class="btn btn-primary btn-md" @click="onFilter(filter)">
            <i class="flaticon2-search-1"></i> Filter
          </button>
        </div>
      </div>
    </div>


    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <div class="d-flex justify-content-end mb-5">
          <button class="btn btn-primary btn-md" >
            <i class="flaticon2-refresh"></i> Load Proyek
          </button>
        </div>

        <complete-table :data="currentProjectDetails" :loading="false">
          <template #header>
            <tr class="text-left">
              <th style="min-width: 250px" class="pl-7">
                <span class="text-dark-75">Kode Proyek</span>
              </th>
              <th style="min-width: 100px">Nama Proyek</th>
              <th style="min-width: 100px">Status</th>
              <th style="min-width: 100px">Owner</th>
              <th style="min-width: 101px">Aksi</th>
            </tr>
          </template>

          <template #defaultBody="{ item, i }">
            <tr v-bind:key="i">
              <td class="pl-0 ">
                <span
                  class="ml-5 text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.code }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.name }}
                </span>
              </td>

              <td>
                <span
                  class="text-dark-75 font-weight-bolder d-block font-size-lg"
                >
                  {{ item.status }}
                </span>
              </td>

              <td>
                <span class="text-muted font-weight-bold d-block">
                  {{ item.owner }}
                </span>
              </td>

              <td class="pr-0">
                <a
                  class="btn btn-light-success font-weight-bolder font-size-sm"
                  @click="toEditPage(item)"
                >
                  <i class="flaticon-edit"></i>
                </a>
              </td>
            </tr>
          </template>
        </complete-table>
      </div>
    </div>
  </div>
</template>

<script>
import { SET_BREADCRUMB } from "@/core/services/store/breadcrumbs.module";
import {
  GET_PROJECT_DETAIL,
  FILTER_PROJECT_DETAIL
} from "@/core/services/store/project.module";
import { mapGetters } from "vuex";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";

export default {
  name: "ordering",
  components: { CompleteTable },
  data() {
    return {
      filter: {
        status: null,
        name: null,
        code: null,
        owner: null,
        contract_num: null
      },
      options: {
        statuses: [
          { value: null, text: "Pilih Status" },
          { value: "open", text: "Open" },
          { value: "close", text: "Close" }
        ]
      },
      data: {
        projects: [
          {
            id: 1,
            code: "LR98123",
            name: "PEMBANGUNAN SISTEM PERSINYALAN",
            status: "Open",
            owner: "BALAI TEKNIK PERKERETAAPIAN"
          }
        ]
      },
      loadingActive: false,
      tableMainProject: true
    };
  },
  methods: {
    toEditPage(data) {
      this.$router.push({
        name: "edit-detail-project",
        params: {
          id: data.code
        }
      });
    },

    onFilter(param) {
      const filter = {
        jobdesk: "design",
        params: {
          code: param.code === null ? "" : param.code,
          status: param.status === null ? "" : param.status,
          name: param.name === null ? "" : param.name,
          owner: param.owner === null ? "" : param.owner,
          contract_num: param.contract_num === null ? "" : param.contract_num
        }
      };
      this.$store.dispatch(FILTER_PROJECT_DETAIL, filter);
    }
  },
  async created() {
    this.$store.dispatch(SET_BREADCRUMB, [{ title: "Detail Proyek" }]);
    await this.$store.dispatch(GET_PROJECT_DETAIL, "design");

    this.loadingActive = true;
    this.tableMainProject = false;
  },
  computed: {
    ...mapGetters(["currentUser", "currentMenus", "currentProjectDetails"])
  }
};
</script>

<style></style>
